aboutsummaryrefslogtreecommitdiff
path: root/debian/gnunet-server.init
diff options
context:
space:
mode:
Diffstat (limited to 'debian/gnunet-server.init')
-rw-r--r--debian/gnunet-server.init146
1 files changed, 98 insertions, 48 deletions
diff --git a/debian/gnunet-server.init b/debian/gnunet-server.init
index 1a77f1e..52bfadc 100644
--- a/debian/gnunet-server.init
+++ b/debian/gnunet-server.init
@@ -1,64 +1,114 @@
-#!/bin/sh
-
+#! /bin/sh
### BEGIN INIT INFO
-# Provides: gnunet-server
-# Required-Start: $syslog $network $local_fs $remote_fs
-# Required-Stop: $syslog $network $local_fs $remote_fs
-# Should-Start:
-# Should-Stop:
-# Default-Start: 2 3 4 5
-# Default-Stop: 0 1 6
-# Short-Description: Starts the GNUnet server at boot time.
-# Description: GNUnet is a secure, trust-based peer-to-peer framework.
+# Provides: gnunet-server
+# Required-Start: $remote_fs $syslog $network
+# Required-Stop: $remote_fs $syslog $network
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: Starts the GNUnet server at boot time.
+# Description: GNUnet is a secure, trust-based peer-to-peer framework.
### END INIT INFO
-PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="GNUnet"
+NAME=gnunet-server
DAEMON=/usr/bin/gnunet-service-arm
-NAME=gnunet-service-arm
-DESC=GNUnet
LOGFILE=/var/log/gnunetd/gnunetd.log
+DAEMON_ARGS="-c /etc/gnunet.conf -d -l $LOGFILE"
+SCRIPTNAME=/etc/init.d/$NAME
-test -x "${DAEMON}" || exit 0
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
-set -e
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
-# Get configuration
-if [ -f /etc/default/gnunet-server ]
-then
- . /etc/default/gnunet-server
-fi
+[ "${GNUNET_AUTOSTART}" != "true" ] && exit 0
-if [ "${GNUNET_AUTOSTART}" != "true" ]
-then
- exit 0
-fi
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
-case "${1}" in
- start)
- echo -n "Starting ${DESC}: "
- start-stop-daemon --start --chuid ${GNUNET_USER} \
- --oknodo --quiet --exec ${DAEMON} -- -c \
- /etc/gnunet.conf -d -l $LOGFILE
- echo "${NAME}."
- ;;
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
- stop)
- echo -n "Stopping ${DESC}: "
- start-stop-daemon --stop --retry 15 \
- --oknodo --quiet --exec ${DAEMON}
- echo "${NAME}."
- ;;
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ start-stop-daemon --start --quiet --exec $DAEMON --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --chuid $GNUNET_USER --exec $DAEMON -- \
+ $DAEMON_ARGS \
+ || return 2
+}
- restart|force-reload)
- ${0} stop
- sleep 1
- ${0} start
- ;;
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --exec $DAEMON
+ RETVAL="$?"
+ [ "$RETVAL" = 2 ] && return 2
+ start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+ [ "$?" = 2 ] && return 2
+ return "$RETVAL"
+}
- *)
- echo "Usage: ${0} {start|stop|restart|force-reload}" >&2
- exit 1
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+ ;;
+ restart|force-reload)
+ log_daemon_msg "Restarting $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
;;
+ esac
+ ;;
+ *)
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
esac
-exit 0
+: